#ifndef LIBHEAD_H
#define LIBHEAD_H

#include "LibFileInfo.h"
#include "LibVal.h"

class LibHead
{
public:

  LibHead() : d_list(NULL) {}
  LibHead(const UString& nm, const LibFileInfo& f, LibValEList* l = NULL) :
    d_name(nm), d_fileInfo(f), d_list(l) {}

  ~LibHead();

  const UString& name() const { return d_name; }
  const LibFileInfo& fileInfo() const { return d_fileInfo; }
  void fileInfo(const LibFileInfo& f) { d_fileInfo = f; }
  LibValEList* list() const { return d_list; }
  void list(LibValEList* l) { d_list = l; }
  LibValIter valIter() {
    if (d_list) {
      return d_list->begin();
    } else {
      return LibValIter(NULL);
    }
  }
  LibVal* nextValue(LibValIter& viter);

private:

  UString          d_name;
  LibFileInfo      d_fileInfo;
  LibValEList* d_list;      // needs to be a pointer so the list can
                                // be given away without copying

};

inline LibVal*
LibHead::nextValue(LibValIter& viter)
{
  if (viter) {
    return (LibVal*)(viter++);
  } else {
    return NULL;
  }
}

#endif

